using System;
using System.Data;
using System.Data.SqlClient;

namespace CustomerForm
{
	/// <summary>
	/// Summary description for clsDataAccess.
	/// </summary>
	public class clsDataAccess
	{
		string sConn = 
			"Data Source=localhost;Integrated Security=SSPI;Initial Catalog=Northwind;";

		public clsDataAccess()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public string GetCustomers()
		{
			try
			{
				// Connect to the data source.
				SqlConnection Conn = new SqlConnection(sConn);
				Conn.Open();

				// Build a dataset containing all the Customer IDs.
				SqlDataAdapter da = new SqlDataAdapter(
					"SELECT CustomerID FROM Customers", Conn);
				DataSet ds = new DataSet();
				da.Fill(ds);

				// Write the dataset to XML and return to the caller
				// as a string.
				System.IO.StringWriter sw = new System.IO.StringWriter();
				ds.WriteXml(sw, System.Data.XmlWriteMode.IgnoreSchema);
				return sw.ToString();
			}
			catch (Exception ex)
			{
				throw new Exception(ex.Message);
			}
		}

		public string GetCustomerRecord(string sCustID)
		{
			try
			{
				// Connect to the data source.
				SqlConnection Conn = new SqlConnection(sConn);
				Conn.Open();

				// Create a dataset for the customer record with the 
				// given CustomerID.
				SqlDataAdapter da = new SqlDataAdapter( String.Format( 
					"Select * From Customers Where CustomerID='{0}'", sCustID),
					Conn);
				DataSet ds = new DataSet();
				ds.DataSetName = "Document";
				da.Fill(ds, "Customers");

				// Return the dataset to the caller as an XML string.
				System.IO.StringWriter sXML = new System.IO.StringWriter();
				ds.WriteXml(sXML,XmlWriteMode.IgnoreSchema);
				sXML.Close();
				return sXML.ToString();
			}
			catch (Exception ex)
			{
				throw new Exception(ex.Message);
			}
		}

		public enum EditType{Insert, Update};

		public bool UpdateCustomer(EditType edt, string sXML)
		{
			try
			{
				// Build a dataset from the XML string passed in by the caller.
				System.IO.StringReader sr = new System.IO.StringReader(sXML);
				DataSet ds = new DataSet();
				ds.ReadXml(sr);                
				sr.Close();
        
				// Connect to the data source and create a new SqlCommand for
				// that connection.
				SqlConnection Conn = new SqlConnection(sConn);
				Conn.Open();
				SqlCommand cmd = new SqlCommand();
				cmd.Connection = Conn;

				// A string array for the Customers field names; 
				// this array helps in building the SQL Commands 
				// for INSERTs or UPDATEs.
				string[] aFields = new string [11]{"CustomerID", "CompanyName",
													  "ContactName", "ContactTitle", "Address", "City", 
													  "Region", "PostalCode", "Country", "Phone", "Fax"};

				switch (edt)
				{
					case EditType.Insert:
						// If the EditType is an Insert, build an INSERT 
						// SQL Command.
						string sInsertCmd = String.Format(
							"INSERT INTO Customers " +
							"({0}, {1}, {2}, {3}, {4}, {5}, {6}, {7}, " + 
							"{8}, {9}, {10}) VALUES (@{0}, @{1}, @{2}, " + 
							"@{3}, @{4}, @{5}, @{6}, @{7}, @{8}, @{9}, " +
							"@{10})", aFields);

						cmd.CommandText = sInsertCmd;
						break;
 
					case EditType.Update:                    
						// If the EditType is an Update, build an UPDATE 
						// SQL Command.
						string sUpdateCmd = String.Format(
							"UPDATE Customers SET " +
							"{1}=@{1}, {2}=@{2}, {3}=@{3}, " +
							"{4}=@{4}, {5}=@{5}, {6}=@{6}, " +
							"{7}=@{7}, {8}=@{8}, {9}=@{9} , {10}=@{10} " +
							"WHERE {0}=@{0}", aFields);
						cmd.CommandText = sUpdateCmd;
						break;
				}

				// Fill the SQL Command parameters using the values in 
				// the dataset.
				for(int f=0;f<=10;f++)
				{
					SqlParameter parm = cmd.Parameters.Add(
						"@" + aFields[f], SqlDbType.Char);
					parm.Value = ds.Tables[0].Rows[0][aFields[f]];
				}

				// Execute the command and close then connection.
				cmd.ExecuteNonQuery();
				Conn.Close();

				return true;
			}
			catch (Exception ex)
			{
				throw new Exception(ex.Message);
			}
		}

	}
}
